#ifndef CVECTOR_HEADER
#define CVECTOR_HEADER

#include <math.h>

class CVector {
public:
	// 3   x,y,z
	float x;
	float y;
	float z;


	// CVector  -  ʱȭѴ.
	CVector();

	CVector(float init_x, float init_y, float init_z);

	// CVector   
	CVector(const CVector& rhs);

	// CVector Ҹ
	~CVector();

	//   -  Ϳ rhs Ͱ  Ѵ.
	float Dot(const CVector& rhs);

	//   - u Ϳ v Ͱ  ͸  ͷ .  
	//     (this = u X v )
	void Cross(const CVector& u, const CVector& v);

	// Ϳ Į k   ͸ Ѵ.
	CVector Scale(float k);

	//   ̸ Ѵ.
	float Length();

	//  Ϳ  ͸ Ѵ.
	CVector Normalize();

	//  
	CVector operator+(const CVector& rhs);		// 纤Ϳ rhs   ͸ Ѵ.
	CVector operator-(const CVector& rhs);		// 纤Ϳ rhs   ͸ Ѵ.
	void operator=(const CVector& rhs);		// rhs    ͷ Ѵ.

};

#endif