#include "UniformMotion.h"
#include "UniformlyAcceleratedMotion.h"
#include <iostream>


//  ӵ 
void UniformMotion()
{
	::std::cout << "ӵ \n";

	CUniformMotion motion(2.0, -1.0, 3.0, 10.0, 3.0, -2.0);
	
	::std::cout << "when time = 5.0\n";
	::std::cout << "position     :\t" << motion.getX(5.0) << '\t' << motion.getY(5.0) << '\t' << motion.getZ(5.0) << '\n';
	::std::cout << "velocity     :\t" << motion.getVz(5.0) << '\t' << motion.getVy(5.0) << '\t' << motion.getVz(5.0) << '\n';
	::std::cout <<  "acceleration :\t" << motion.getAx(5.0) << '\t' << motion.getAy(5.0) << '\t' << motion.getAz(5.0) << '\n';
}

//  ӵ 
void UniformlyAcceleratedMotion()
{
	::std::cout << "\nӵ \n";

	CUniformlyAcceleratedMotion motion(-0.5, -2.0, 4.0, 12.0, 0.0, -3.0, 21.0, 9.0, 11.0);
	
	::std::cout << "when time = 5.0\n";
	::std::cout << "position     :\t" << motion.getX(5.0) << '\t' << motion.getY(5.0) << '\t' << motion.getZ(5.0) << '\n';
	::std::cout << "velocity     :\t" << motion.getVz(5.0) << '\t' << motion.getVy(5.0) << '\t' << motion.getVz(5.0) << '\n';
	::std::cout << "acceleration :\t" << motion.getAx(5.0) << '\t' << motion.getAy(5.0) << '\t' << motion.getAz(5.0) << '\n';
}

int main()
{
	//
	UniformMotion();
	UniformlyAcceleratedMotion();

	::std::cout.flush();
	return 0;
}
